import { world, system, TimeOfDay } from "@minecraft/server";


let scoreboard = world.scoreboard;
export const overworld = world.getDimension('overworld');
export const nether = world.getDimension('nether');
export const the_end = world.getDimension('the_end');
export const dimensions = [overworld, nether, the_end];

export let player0 = undefined;


export function randomInt(min, max) {
	return Math.floor(Math.random() * (max - min + 1))+min;
}
export function floorVector(vector)
{
	return { x: Math.floor(vector.x), y: Math.floor(vector.y+0.5), z: Math.floor(vector.z) };
}

export async function waitForTicks(ticks, func) {
    return await system.runTimeout(func, ticks);
}


export async function waitForLoopEvent(ticks, callback) {
    return new Promise(resolve => {
        let id = 0;
        const event = async function () {
            var _a;
            if (await callback()) {
                resolve();
            }
            else {
                id = system.runTimeout(event, ticks);
            }
        };
        system.run(event);
    });
}

export async function onLoad() {
	if (player0)
		return;
	
	await waitForLoopEvent(1, () => {
		return world.getAllPlayers().length > 0;
	});
	player0 = await world.getAllPlayers()[0];
	
	if (!player0.hasTag("pu_se_player0"))
		player0.addTag("pu_se_player0");
}


export async function runCommand(command) {
	return await overworld.runCommandAsync(command);
}

export async function runPlayer0Command(command) {
	return await player0.runCommandAsync(command);
}

export async function runPlayerCommand(entity, command) {
	return await entity.runCommandAsync(command);
}
export async function runDelayedPlayerCommand(delay, entity, command) {
	return await system.runTimeout(() => { runPlayerCommand(entity, command); }, delay);
}
export async function runDelayedEntityCommand(delay, entity, command) {
	return await system.runTimeout(() => { runEntityCommand(entity, command); }, delay);
}
export async function runMobCommand(entity, command) {
	return await entity.runCommandAsync(command);
}
export async function runEntityCommand(entity, command) {
	return await entity.runCommandAsync(command);
}

export async function getEntities(entityType)
{
	const entities = await dimensions.flatMap((dim) => (dim.getEntities({ type: entityType })));
	return entities;
}
export async function getEntityInLocation(entityType, dim, centerLocation)
{
	const entities = await dim.getEntities( { type: entityType, location: centerLocation, closest: 1 } );
	return entities;
}
export async function getPlayerInLocation(dim, centerLocation)
{
	const players = await dim.getPlayers( { location: centerLocation, closest: 1 } );
	return players;
}
export async function getPlayersInRange(dim, centerLocation, minDist, maxDist)
{
	const players = await dim.getPlayers( { location: centerLocation, minDistance: minDist, maxDistance: maxDist } );
	return players;
}
export async function getEntitiesInRange(entityType, dim, centerLocation, minDist, maxDist)
{
	const entities = await dim.getEntities( { type: entityType, location: centerLocation, minDistance: minDist, maxDistance: maxDist } );
	return entities;
}

export async function countItemInInventory(player, itemTypeId)
{
	const inventory = player.getComponent("minecraft:inventory").container;
	let itemCount = 0;
	for (let i = 0; i < inventory.size; i++) {
		let item = inventory.getItem(i);
		if (item !== undefined && item.typeId === itemTypeId)
			itemCount += item.amount;
	}
	return itemCount
}
export async function showPlayerErrorMessage(player, message)
{
	await runPlayerCommand(player, "title @s actionbar "+message);
	await player.playSound("pu_se:error", { volume: 0.8 } );
	//await runPlayerCommand(player, "playsound pu_se:error @s ~ ~ ~ 1.00 1.00 1.00");
}

export async function tellraw(entity, target, msg) {
	return await entity.runCommandAsync(`tellraw ${target} {"rawtext":[{"text":"§r${msg}"}]}`);
}

export async function title(entity, target, msg) {
	return await entity.runCommandAsync(`titleraw ${target} title {"rawtext":[{"text":"§r${msg}"}]}`);
}
export async function subtitle(entity, target, msg) {
	return await entity.runCommandAsync(`titleraw ${target} subtitle {"rawtext":[{"text":"§r${msg}"}]}`);
}
export async function actionbar(entity, target, msg) {
	return await entity.runCommandAsync(`titleraw ${target} actionbar {"rawtext":[{"text":"§r${msg}"}]}`);
}

export async function playSound(entity, target, playSound, volume, pitch, minVolume) {
	let soundVolume = volume ? volume : 100;
	let soundPitch = pitch ? pitch : 1;
	let soundMinVolume = minVolume ? minVolume : 1;
	return await entity.runCommandAsync(`playsound ${playSound} ${target} ~ ~ ~ ${soundVolume} ${soundPitch} ${soundMinVolume}`);
}

export function concat2LinesWithPad(line1, line2)
{
	let len1 = line1.length;
	let len2 = line2.length;
	let message = "";
	if (len1 > len2) 
		message = line1 + "\n" + line2.padStart((len2+((len1-len2)/2)), " ");
	else if (len2 > len1)
		message = line1.padStart((len1+((len2-len1)/2)), " ") + "\n" + line2;
	else 
		message = line1 + "\n" + line2;
	return message;
}
export function debug(message) {
	return world.sendMessage(message);
}


